from PG_utils import *
from PG import *
from FQE_REINFORCE import *

def OPPG(states, actions, next_states, rewards, policy_net, optimizer, env, num_episode, gamma, H, eps):
    score_his = []
    result = []
    bar = range(num_episode)
    for _ in bar:
        curr_states, curr_actions, curr_next_states, curr_rewards = collect_data(env, policy_net, 100, H)
        score_his += get_cumu_discounted_rewards(curr_rewards, 1)
        result.append(print_score(score_his))

        optimizer.zero_grad()
        sample_gradient_w(policy_net, states, actions, rewards, eps, gamma)
        #print(np.linalg.norm(sample_gradient_w(policy_net, states, actions, rewards, eps, gamma)))
        #sample_gradient_w_verbose(policy_net, states, actions, rewards, eps, gamma)
        optimizer.step()

    return result

def OPFPG(states, actions, next_states, rewards, policy_net, optimizer, env, feature, num_episode, gamma, H, d, m, lam=0, sample_s=100):
    score_his = []
    result = []
    bar = range(num_episode)

    features = get_features(states, actions, feature)

    for i in bar:
        curr_states, curr_actions, curr_next_states, curr_rewards = collect_data(env, policy_net, 100, H)
        score_his += get_cumu_discounted_rewards(curr_rewards, 1)
        result.append(print_score(score_his))

        optimizer.zero_grad()
        compute_gradient(env, features, next_states, rewards, policy_net, feature, H, d, m, sample_s, lam)
        optimizer.step()

    return result
